traits.h File Reference
`#include <set>`
`#include <vector>`
`#include <polybori/pbori_defs.h>`
`#include <polybori/common/tags.h>`
`#include <boost/preprocessor/cat.hpp>`
`#include <boost/preprocessor/seq/for_each.hpp>`
`#include <boost/preprocessor/facilities/expand.hpp>`
`#include <boost/preprocessor/stringize.hpp>`

Go to the source code of this file.

## Classes

class | polybori::pbori_traits< ValueType >
| This class contains property definitions to be used in polybori classes. More...
class | polybori::pbori_traits< void >
class | polybori::pbori_traits< int >
class | polybori::pbori_traits< unsigned int >
class | polybori::pbori_traits< long int >
class | polybori::pbori_traits< std::set< ValueType > >
class | polybori::pbori_traits< std::vector< ValueType > >
class | polybori::pbori_binary_traits< FirstType, SecondType >
| This class contains property definitions related to two types to be used in polybori classes. More...
class | polybori::pbori_binary_traits< OnlyType, OnlyType >
class | polybori::pbori_binary_traits< FirstType, SecondType >
| This class contains property definitions related to two types to be used in polybori classes. More...
struct | polybori::manager_traits< MgrType >
struct | polybori::manager_traits< MgrType >
struct | polybori::cudd_error_traits< ErrorNumber >

## Namespaces

| polybori

## Constant Groups

| polybori

## Macros

#define | PB_DECLARE_CUDD_TYPES(fromspace)
#define | PB_BINARY_FUNC_CALL(count, funcname, arg_pair)
#define | PB_CUDD_ERROR_TRAITS(errcode, errstr)

## Typedefs

typedef pbori_DdManager | polybori::DdManager

## Detailed Description

Author
  Alexander Dreyer

Date
  2006-04-24

This file defines properties of built-in an polybori types.

Copyright:
  (c) 2006-2010 by The PolyBoRi Team

## Macro Definition Documentation

#define PB_BINARY_FUNC_CALL | ( |  | count,
|  |  | funcname,
|  |  | arg_pair
| ) |  |

Value:
BOOST_PP_EXPAND(funcname(BOOST_PP_SEQ_HEAD(arg_pair), \
BOOST_PP_SEQ_HEAD(BOOST_PP_SEQ_TAIL(arg_pair))))

#define PB_CUDD_ERROR_TRAITS | ( |  | errcode,
|  |  | errstr
| ) |  |

Value:
template<> inline cudd_error_traits<errcode>::result_type \
cudd_error_traits<errcode>::operator()() const { \
return BOOST_PP_STRINGIZE(errstr); }

#define PB_DECLARE_CUDD_TYPES | ( |  | fromspace) |  |

Value:
typedef fromspace::errorfunc_type errorfunc_type; \
typedef fromspace::large_size_type large_size_type; \
typedef fromspace::refcount_type refcount_type; \
typedef fromspace::node_type node_type; \
typedef fromspace::mgrcore_type mgrcore_type; \
typedef fromspace::unary_int_function unary_int_function; \
typedef fromspace::void_function void_function; \
typedef fromspace::binary_function binary_function; \
typedef fromspace::binary_int_function binary_int_function; \
typedef fromspace::ternary_function ternary_function; \
typedef fromspace::int_unary_function int_unary_function; \
typedef fromspace::size_type size_type;\
typedef fromspace::idx_type idx_type;